#####
###  Abracadabra Object - pre-configured objects with only one click
##   Copyright (C) 2002 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

from re import sub
from urllib import quote
from DateTime import DateTime
from Globals import DTMLFile, InitializeClass
from CharacterMapping import CharacterMapping

def _scriptWrapper(self, client, object_id, REQUEST):

    callObj = getattr(self.standard_object_folder, object_id)

    if callObj.meta_type == 'Script (Python)':                 
        callObj._exec({'context': client, 
                       'container': callObj.aq_parent,
                       'script': callObj,
                       'traverse_subpath': ''},
                       [], {})
    else:
        callObj(client, REQUEST)

    return(callObj)
        
def manage_addAbracadabraObject(self, id, object_id, title = '', REQUEST = None, submit = None):
    """ Call a script object_id_ or clone object_id from standard_object_folder """
    
    # check for auto_id in the standard_object_folder    
    
    auto_id = self.standard_object_folder.getProperty('auto_id', None)
    
    if not id and auto_id:     
        # we have a list? search the entry for object_id
        if type(auto_id) == type([]):
            autoIds = auto_id
            auto_id = None
            for line in autoIds:
                if ':' in line:
                    (objStr,fmtStr) = line.split(':', 1)
                    if objStr == object_id:
                        auto_id = fmtStr
                
        # auto_id as string-property
        if type(auto_id) == type(''):
            fmt = auto_id
            
            if fmt.find('%s') <> -1 and title <> '':
                cookTitle = title

                # sub some chars before replacing id-invalids with underscores
                for fromChar in CharacterMapping.keys():
                    cookTitle = cookTitle.replace(fromChar, CharacterMapping[fromChar])

                # then remove leading and ending underscores...
                id = sub('^_*|_*$', '', (fmt % sub('[\W]+','_', cookTitle)))

            else:
                tmpId = len(self.objectIds())               
                # to be sure: test and search for a free id...
                while hasattr(self, fmt % tmpId): 
                    tmpId = tmpId + 1
                id = fmt % tmpId

        elif type(auto_id) == type(0):
            id = auto_id
            while hasattr(self, str(id)):
                id = id + 1
            self.standard_object_folder.manage_changeProperties({'auto_id': id + 1})
    
        elif auto_id:
            id = DateTime().millis()
            # to be sure: test and search for a free id...
            while hasattr(self, "%s" % str(id)):
                id = id + 1 

    # we need a string - cast to be sure that we have one!
    id = str(id)    
    
    # Script-Call - obect_id ends on an underscore, so call it as a script
    if object_id[-1] == '_':
        context = self
        callObj = _scriptWrapper(self, context, object_id, REQUEST)
       
    # Clone-Call - object_id ends on no underscore, so copy the object
    else:
        context = self.manage_clone(getattr(self.standard_object_folder, object_id), id, REQUEST)
        context.title = str(title)
        # Test if a corresponding object_id with an underscore exists and call it         
        if hasattr(self.standard_object_folder, object_id + '_'):
            callObj = _scriptWrapper(self, context, object_id + '_', REQUEST)

    if REQUEST:
        try: u = self.DestinationURL()
        except: u = REQUEST['URL1']

        if submit == " Add and Edit Properties ":
            if hasattr(context.aq_explicit, 'manage_propertiesForm'):
                u = "%s/%s/manage_propertiesForm" % (u, quote(id))
            else:
                u = "%s/%s/manage_main" % (u, quote(id))
                
        elif submit == " Add and Edit ":
            u = "%s/%s/manage_main" % (u, quote(id))

        else:
            u = "%s/manage_main" % (u)
                
        REQUEST.RESPONSE.redirect(u)

    return id

manage_addAbracadabraObjectForm = DTMLFile('dtml/addAbracadabraObject', globals())

class AbracadabraObject:
    """ AbracadabraObject - pre-configured objects with only one click """

    meta_type = "Abracadabra Object"
    __ac_permissions__ = ( (('Abracadabra Object: Show StandardSelectBox'),()),)
    
InitializeClass(AbracadabraObject)
